// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package gamelift provides the client and types for making API
// requests to Amazon GameLift.
//
// Amazon GameLift provides a range of multiplayer game hosting solutions. As
// a fully managed service, GameLift helps you:
//
//    * Set up EC2-based computing resources and use GameLift FleetIQ to and
//    deploy your game servers on low-cost, reliable Spot instances.
//
//    * Track game server availability and route players into game sessions
//    to minimize latency.
//
//    * Automatically scale your resources to meet player demand and manage
//    costs
//
//    * Optionally add FlexMatch matchmaking.
//
// With GameLift as a managed service, you have the option to deploy your custom
// game server or use Amazon GameLift Realtime Servers to quickly stand up lightweight
// game servers for your game. Realtime Servers provides an efficient game server
// framework with core Amazon GameLift infrastructure already built in.
//
// Now in Public Preview:
//
// Use GameLift FleetIQ as a standalone feature with EC2 instances and Auto
// Scaling groups. GameLift FleetIQ provides optimizations that make low-cost
// Spot instances viable for game hosting. This extension of GameLift FleetIQ
// gives you access to these optimizations while managing your EC2 instances
// and Auto Scaling groups within your own AWS account.
//
// Get Amazon GameLift Tools and Resources
//
// This reference guide describes the low-level service API for Amazon GameLift
// and provides links to language-specific SDK reference topics. See also Amazon
// GameLift Tools and Resources (https://docs.aws.amazon.com/gamelift/latest/developerguide/gamelift-components.html).
//
// API Summary
//
// The Amazon GameLift service API includes two key sets of actions:
//
//    * Manage game sessions and player access -- Integrate this functionality
//    into game client services in order to create new game sessions, retrieve
//    information on existing game sessions; reserve a player slot in a game
//    session, request matchmaking, etc.
//
//    * Configure and manage game server resources -- Manage your Amazon GameLift
//    hosting resources, including builds, scripts, fleets, queues, and aliases.
//    Set up matchmakers, configure auto-scaling, retrieve game logs, and get
//    hosting and game metrics.
//
//   Task-based list of API actions (https://docs.aws.amazon.com/gamelift/latest/developerguide/reference-awssdk.html)
//
// See https://docs.aws.amazon.com/goto/WebAPI/gamelift-2015-10-01 for more information on this service.
//
// See gamelift package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/gamelift/
//
// Using the Client
//
// To contact Amazon GameLift with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon GameLift client GameLift for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/gamelift/#New
package gamelift
